close all
clearvars

load('wksp_3000_Delta_012_ncells.mat')
EfficiencyCoeffDelta = EfficiencyCoeff;

load('wksp_3000_Jag_012_ncells.mat')
EfficiencyCoeffJag = EfficiencyCoeff;

load('wksp_000_Delta_012_ncells.mat')
EfficiencyCoeffNo = EfficiencyCoeff;

x=[EfficiencyCoeffNo'; EfficiencyCoeffJag'; EfficiencyCoeffDelta'];
g = [ones(size(EfficiencyCoeffNo')); 2*ones(size(EfficiencyCoeffJag'));...
    3*ones(size(EfficiencyCoeffDelta'))];

boxplot(x,g)
xlabel('Ligand type')
ylabel('E_{CS} [%]')
yticks([0 0.5 1])
yticklabels({'0', '50', '100'})
xticklabels({'No', 'Jag1', 'Dll4'})
box on
set(gca, 'Fontsize', 20, 'linewidth', 2)
set(findobj(gca,'type','line'),'linew',2)
set(gca, 'Fontsize', 20, 'linewidth', 2)
axis([0.5 3.5 0 1.05])
colors = rand(4, 3);
h = findobj(gca,'Tag','Box');
patch(get(h(3),'XData'),get(h(3),'YData'),[51,34,136]/255,'FaceAlpha',.5,'LineWidth',2);
patch(get(h(2),'XData'),get(h(2),'YData'),[221,204,119]/255,'FaceAlpha',.5,'LineWidth',2);
patch(get(h(1),'XData'),get(h(1),'YData'),[170,68,153]/255,'FaceAlpha',.5,'LineWidth',2);
 
title('Representative, Molec.=3000')

percentile = 90;
boxplot([x(1:10000), x(10001:20000), x(20001:30000)])
% Check the size of percentile variable and expand if needed
if length(percentile) == 1 && percentile>50
    percentile = [100-percentile, percentile];      % symmetric percentile vector which will cover the requested span
elseif length(percentile) == 1 && percentile<50
    percentile = [percentile, 100-percentile];
end


% get the necessary handles.
b = get(gca,'children');                            % get children of the axes, which is a boxplot "group" of lines
c = get(b,'children');                              % the children of b are individual line arrays
UW = findobj(c,'Tag','Upper Whisker');              % get the UpperWhisker line array
UAJ = findobj(c,'Tag','Upper Adjacent Value');      % the Upper Crossbar line array
OUT = findobj(c,'Tag','Outliers');                  % upper outliers
LW = findobj(c,'Tag','Lower Whisker');              % Lower whisker line array
LAJ = findobj(c,'Tag','Lower Adjacent Value');      % lower crossbar

data=[x(1:10000), x(10001:20000), x(20001:30000)];
m = 3;                                 % size of data array    
P = prctile(data, percentile);                      % percentiles
if m == 1, P = P(:); end
lowerWhisker = P(1,:);                              % location of lower whiskers
upperWhisker = P(2,:);                              % location of upper whiskers

for i = 1:m

    UW_lims = get(UW(m-i+1),'ydata');                        % current upper whisker points
    set(UW(m-i+1),'ydata',[UW_lims(1) upperWhisker(i)]);     % set to same lower, new upper
    set(UAJ(m - i + 1),'ydata',[1 1]*upperWhisker(i));       % move the upper crossbar
    
    LW_lims = get(LW(m - i + 1),'ydata');                    % current lower whisker points
    set(LW(m-i+1),'ydata',[lowerWhisker(i), LW_lims(2)]);    % set to new lower, same upper       
    set(LAJ(m - i + 1),'ydata',[1 1]*lowerWhisker(i));       % move the lower crossbar
    
    index = data(:,i) > upperWhisker(i) | ...
            data(:,i) < lowerWhisker(i);   
            
    outliers = sort(data(index,i));                         % sort the outliers
    set(OUT(m-i+1),'Ydata',outliers);                       % reset the outliers
    xvals = OUT(m-i+1).XData;                               % get the xvalues for the outliers
    nx = length(xvals);                                     % number of xvalues
    nOut = length(outliers);                                % number of outliers
    index = randsample(nx,nOut,true);                       % resample the xvalues with replacement
    xvals = xvals(index);                                   % create a new vector of x values
    set(OUT(m-i+1),'Xdata',xvals);                          % reset the xvalues
end
xlabel('Ligand type')
ylabel('E_{CS} [%]')
yticks([0 0.5 1])
yticklabels({'0', '50', '100'})
xticklabels({'No', 'Jag1', 'Dll4'})
box on
set(gca, 'Fontsize', 20, 'linewidth', 2)
set(findobj(gca,'type','line'),'linew',2)
set(gca, 'Fontsize', 20, 'linewidth', 2)
axis([0.5 3.5 0 1.05])
colors = rand(4, 3);
h = findobj(gca,'Tag','Box');
patch(get(h(3),'XData'),get(h(3),'YData'),[51,34,136]/255,'FaceAlpha',.5,'LineWidth',2);
patch(get(h(2),'XData'),get(h(2),'YData'),[221,204,119]/255,'FaceAlpha',.5,'LineWidth',2);
patch(get(h(1),'XData'),get(h(1),'YData'),[170,68,153]/255,'FaceAlpha',.5,'LineWidth',2);
 
title('Representative, Molec.=3000')