%25 may
function Neighbors = extp_F_dt_oneway_DeltaJaggedPattern(ncells,Notch,Delta,Jagged,NICD,i,Dp,Jp,patternyesno)

%handles.value meegeven, if h == 1 initial, h == 2 several, etc

% Edited by Sandra Loerakker: polarization of Jagged

% sum external proteins of Notch (Nt)        
% ------------------------------------------------------------------------------------------------- 
% Notch
N = zeros(1,ncells+2);
N(1,ncells+2) = Notch(i,1);
N(1,1) = Notch(i,ncells);
N(1,(2:(ncells+1))) = Notch(i,:);

N_l = N(1,(1:ncells)); % N[i-1] 
N_r = N(1,(3:ncells+2)); % N[i+1]

% Delta
D = zeros(1,ncells+2);
D(1,ncells+2) = Delta(i,1);
D(1,1) = Delta(i,ncells);
D(1,(2:(ncells+1))) = Delta(i,:);

D_l = D(1,(1:ncells)); % D[i-1] 
D_r = D(1,(3:ncells+2)); % D[i+1]
D_p = Dp*ones(1,ncells);
if patternyesno == 1
    for kk = 1:ncells
        if kk>ncells/4 && kk<=(ncells-ncells/4)
            D_p(kk)=0;
        end
    end
end

% Jagged

% continuous pulse EC
J = zeros(1,ncells+2);
J(1,ncells+2) = Jagged(i,1);
J(1,1) = Jagged(i,ncells); 
J(1,(2:(ncells+1))) = Jagged(i,:);

J_l = J(1,(1:ncells)); % J[i-1] 
J_r = J(1,(3:ncells+2)); % J[i+1]

J_p = Jp*ones(1,ncells);
if patternyesno == 1
    for kk = 1:ncells
        if kk>ncells/4 && kk<=(ncells-ncells/4)
            J_p(kk)=0;
        end
    end
end

% NICD for i == N 
I = zeros(1,ncells+2);
I(1,ncells+2) = NICD(i,1);
I(1,1) = NICD(i,ncells);
I(1,(2:(ncells+1))) = NICD(i,:);

I_l = I(1,(1:ncells)); % I[i-1] 
I_r = I(1,(3:ncells+2)); % I[i+1]

% calculate Ne, De and Je for each cell
Neighbors = zeros(4,ncells);
Neighbors(1,:) = 0.5*(N_l + N_r); % NeD   
Neighbors(2,:) = 0.5*(N_l + N_r); % NeJ   
Neighbors(3,:) = 0.5*(D_l + D_r)+D_p; % De
Neighbors(4,:) = 0.5*(J_l + J_r)+J_p; % Je
